
#ifndef UGEN_H
#define UGEN_H

typedef struct ugen_s {
    char name[32];

    void (*process)(void *data);
    void (*destroy)(void *data);
    void (*set_param)(void *data, int index, double value);
    double * (*get_input)(void *data, int index);
    void (*set_output)(void *data, int index, double *out_buffer);

    struct ugen_s *next;
} ugen_t;

#endif
