#include <inttypes.h>

#include "ugen.h"

typedef enum {
    MULT_IN1 = 0,
    MULT_IN2,
    MULT_NUM_PARAMS
} MULT_PARAMS;

typedef struct {
    double *in1;
    double *in2;
    double *out;
} MULT_DATA;

void *mult_construct();

void mult_process(void *data);

void mult_destroy(void *data);

void mult_set_param(void *data, int index, double value);

double *mult_get_input(void *data, int index);

void mult_set_output(void *data, int index, double *out_buffer);

void mult_get_ugen_info(ugen_t *ugen_data);



